> For the complete documentation index, see [llms.txt](https://docs.datacake.de/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.datacake.de/lorawan/payload-decoders/access-measurements.md).

# Access Measurements in LoRaWAN Decoders

## Concept

The global `measurements` object allows you to access the device's current measurements. It is structured like this:

```javascript
{
  "BATTERY": {
    "field_name": "BATTERY",
    "timestamp": "1600378287",
    "value": 3.301
  },
  "SOIL_CONDUCTIVITY": {
    "field_name": "SOIL_CONDUCTIVITY",
    "timestamp": "1600378287",
    "value": 121
  }
}
```

### Code Example

```javascript
function decoder() {
    
    // get current value from field in Database
    var field_in_db = measurements.FIELD_IN_DB.value;
    
}
```

## Building Counters

If you want to build absolute counters you can use the database access on a decoder in order to read the currently stored value, add a new count and store back the new and updated count. We show you how you can do that.

```javascript
function decoder(bytes, port) {
    
    // relative change between messages will reset to zero with every sensor uplink
    var relativeNumber = bytes[0]; 
    
    // get current value from field in Database
    var absoluteNumber = measurements["ABSOLUTE_CHANGE"].value;
    
    // add relative change to absolute number
    absoluteNumber = absoluteNumber + relativeNumber;
    
    // store back absolute number
    return [{
        field: "ABSOLUTE_CHANGE",
        value: absoluteNumber
    }]
    
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.datacake.de/lorawan/payload-decoders/access-measurements.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
